﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TEXIO_TCPIP_Test
{
    public partial class Form1 : Form
    {

        private int Opened;
        private System.Net.Sockets.TcpClient m_TcpClient;           // TCPクライアント
        private System.Net.Sockets.NetworkStream m_NetworkStream;   // ネットワークストリーム

        public Form1()
        {
            InitializeComponent();
            btnOpen_Close.Text = "OPEN";
            txtSendMsg.Text = "*idn?";
            btnRead.Enabled = false;
            btnSend.Enabled = false;
            txtSocket.Enabled = true;
            txtIPAddress.Enabled = true;
        }
        // Form Close(x Button)
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Device Close
            if (Opened != 0)
            {
                if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                {
                    this.m_NetworkStream.Close();
                    this.m_TcpClient.Close();
                }
                this.m_NetworkStream = null;
                this.m_TcpClient = null;
            }
        }

        private void btnOpen_Close_Click(object sender, EventArgs e)
        {


            if (btnOpen_Close.Text == "OPEN")
            {
                try
                {

                    Cursor.Current = Cursors.WaitCursor;

                    // Device Open and Init
                    this.m_TcpClient = new System.Net.Sockets.TcpClient();
                    this.m_TcpClient.Connect(txtIPAddress.Text, int.Parse(txtSocket.Text));
                    this.m_NetworkStream = this.m_TcpClient.GetStream();

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnRead.Enabled = true;
                    btnSend.Enabled = true;
                    txtSocket.Enabled = false;
                    txtIPAddress.Enabled = false;
                    Opened = 1;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    this.m_NetworkStream = null;
                    this.m_TcpClient = null;
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else
            {
                if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                {
                    this.m_NetworkStream.Close();
                    this.m_TcpClient.Close();
                }
                this.m_NetworkStream = null;
                this.m_TcpClient = null;
                Opened = 0;
                btnOpen_Close.Text = "OPEN";
                txtSendMsg.Text = "*idn?";
                btnRead.Enabled = false;
                btnSend.Enabled = false;
                txtSocket.Enabled = true;
                txtIPAddress.Enabled = true;
            }
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            string SendMsg;

            SendMsg = txtSendMsg.Text  + "\n";
            try
            {
                WriteLine(SendMsg);
                if (SendMsg.IndexOf("?") >= 0)
                {
                    System.Threading.Thread.Sleep(200);
                    btn_Read();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            btn_Read();
        }
        private void btn_Read()
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                txtReadMsg.Text = Readbuff() + "\r\n";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }
        private void WriteLine(string sendMsg)
        {
            byte[] SendBuff = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetBytes(sendMsg);
            m_NetworkStream.Write(SendBuff, 0, SendBuff.Length);
            m_NetworkStream.Flush();
        }
        private string Readbuff()
        {
            byte[] reciveBufff = new byte[256];

            int DataCnt = this.m_TcpClient.Available;
            if (DataCnt > 255) DataCnt = 255;
            m_NetworkStream.Read(reciveBufff, 0, DataCnt);
            return System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(reciveBufff).Substring(0, DataCnt);
        }
    }
}
